/* triarea3.c --- c code for calculating the area of a triangle in 3D */

 /* Dan Lofgreen 28 August 2006
 *
 * This software is distributed free under the conditions that
 * (1) it shall not be incorporated in software that is subsequently sold
 * (2) the authorship of the software shall be acknowledged in any 
 *     publication that uses results generated by the software
 * (3) this notice shall remain in place in each file.
 *
 * GPL applies: http://www.gnu.org/copyleft/gpl.html
 */ 

/*
 * See SpatialAnalysis.h file for declaration details
 *
 */


#include <math.h>

/* triarea calculates the area of a triangle in 3D space */
double triarea3(double *x, double *y, double *z)
{
    int i;
    double si[3], s, A;
    
    si[0] = sqrt((x[1]-x[0])*(x[1]-x[0]) + (y[1]-y[0])*(y[1]-y[0])
        + (z[1]-z[0])*(z[1]-z[0]));
    si[1] = sqrt((x[2]-x[1])*(x[2]-x[1]) + (y[2]-y[1])*(y[2]-y[1])
        + (z[2]-z[1])*(z[2]-z[1]));
    si[2] = sqrt((x[0]-x[2])*(x[0]-x[2]) + (y[0]-y[2])*(y[0]-y[2])
        + (z[0]-z[2])*(z[0]-z[2]));
    
    s = (si[0] + si[1] + si[2])/2.0;
    
    /* Calculate the area as */
    A = s;
    for(i=0; i<3; i++)
        A = A*(s-si[i]);
   
    return(sqrt(A));    
}
