% DMIN3D  Simulate Dmin rule in 3d.
% Typical usage:
% [P,R,D] = DMIN3D(NPTS, BOX, DMIN);
%
% Input arguments:
%
% NPTS: number of points to generate.
% BOX:  3-vector storing [wid height depth] of volume to
% simulate.
% DMIN: 4-vector storing [mean sd lower upper] describing the
% parameters of the Normal distribution.  Random values outside the
% range of lower to upper are ignored.  lower is typically the
% soma size diameter, and if upper is negative, there is no upper limit.
% 
% Output arguments:
%
% P: [NPTS,3] matrix storing the simulated points.
% R: NPTS-vector storing the number of rejected  when positioning
% each cell. 
% D: successful dmin value used for each point.
% I: extra information about the simulation.  I is a 2-d vector;
%    I[1] is the total number of rejects (= sum(r))
%    I[2] is an estimate of the packing density.
%
% If the simulation could not be made (beyond the packing density),
% P is set to -1.  (R and D store the values up to the point where
% the simulation was aborted.)
%
% Example:
% [p,r,d,i] = dmin3d(200, [300 300 300], [40, 5, 10, -1]);
%
%  To compile this mex function in Windows, use the following:
%
%     mex -v dmin3d.c


