%PYRAMIDAREA Calculate area of a triangular pyramid
%  [AREA,VECT] = PYRAMIDAREA(X,K,P)  Calculates the surface area and 
%  direction vector for each triangular pyramid in a delaunay tessellation 
%  or voronoi diagram.  The function accepts an Nx3 matrix, X, of vertices,
%  where the first column is the x coordinates, the second y corrdinates 
%  and the third the z coordinates.  An Mx3 matrix, K, of indices into X.  
%  These represent the 3 points that make up the base of the pyramid.  
%  Finally a 1x3 vector, P, that has the [x,y,z] coordinates of the point 
%  of interest, or the apex of the pyramid.
%
%  The function returns an Mx1 vector, AREA, that is the area of the base 
%  of each pyramid.  The function also returns an Mx3 vector, VECT, that is
%  the sum of the 3 vectors from the apex to each point on the base of the
%  pyramid.  The resultant vectors are not normalized.
%  
%  To compile this mex function in Windows, use the following:
%     mex -v pyramidarea.c triarea3.c
%
%   See also CONVHULLN, PYRAMIDVOL

