%PYRAMIDVOL Calculate volume of a triangular pyramid
%  [VOL,A] = PYRAMIDVOL(X,K,P)  Calculates the surface area and volume
%  for each triangular pyramid in a delaunay tessellation or voronoi
%  diagram.  The function accepts an Nx3 matrix, X, of vertices, where the
%  first column is the x coordinates, the second y corrdinates and the
%  third the z coordinates.  An Mx3 matrix, K, of indices into X.  These
%  represent the 3 points that make up the base of the pyramid.  Finally a
%  1x3 vector, P, that has the [x,y,z] coordinates of the point of
%  interest, or the apex of the pyramid.
%
%  The function returns an Mx1 vector, VOL, that is the volume of each
%  pyramid defined by K.  The function also returns an Mx1 vector, A, that 
%  is the area of the base of each pyramid.
%  
%  The volume of a triangular pyramid is 1/3 * Abase * height
%
%  To compile this mex function in Windows, use the following:
%     mex -v pyramidvol.c triarea3
%
%   See also CONVHULLN, PYRAMIDAREA
